/*
	SHARP PC-G800 series emulator
*/

#if !defined(DEPEND_H)
#define DEPEND_H

#include <stdio.h>
#include "SDL.h"
#include "sdlxpm.h"

/*
	}N
*/
/* G~[g}ṼL[R[h */
#define KEY_NONE	SDLK_FIRST
#define KEY_BACKSPACE	SDLK_BACKSPACE
#define KEY_TAB	SDLK_TAB
#define KEY_CLEAR	SDLK_CLEAR
#define KEY_RETURN	SDLK_RETURN
#define KEY_PAUSE	SDLK_PAUSE
#define KEY_ESCAPE	SDLK_ESCAPE
#define KEY_SPACE	SDLK_SPACE
#define KEY_EXCLAIM	SDLK_EXCLAIM
#define KEY_QUOTEDBL	SDLK_QUOTEDBL
#define KEY_HASH	SDLK_HASH
#define KEY_DOLLAR	SDLK_DOLLAR
#define KEY_AMPERSAND	SDLK_AMPERSAND
#define KEY_QUOTE	SDLK_QUOTE
#define KEY_LEFTPAREN	SDLK_LEFTPAREN
#define KEY_RIGHTPAREN	SDLK_RIGHTPAREN
#define KEY_ASTERISK	SDLK_ASTERISK
#define KEY_PLUS	SDLK_PLUS
#define KEY_COMMA	SDLK_COMMA
#define KEY_MINUS	SDLK_MINUS
#define KEY_PERIOD	SDLK_PERIOD
#define KEY_SLASH	SDLK_SLASH
#define KEY_0	SDLK_0
#define KEY_1	SDLK_1
#define KEY_2	SDLK_2
#define KEY_3	SDLK_3
#define KEY_4	SDLK_4
#define KEY_5	SDLK_5
#define KEY_6	SDLK_6
#define KEY_7	SDLK_7
#define KEY_8	SDLK_8
#define KEY_9	SDLK_9
#define KEY_COLON	SDLK_COLON
#define KEY_SEMICOLON	SDLK_SEMICOLON
#define KEY_EQUALS	SDLK_EQUALS
#define KEY_GREATER	SDLK_GREATER
#define KEY_QUESTION	SDLK_QUESTION
#define KEY_LEFTBRACKET	SDLK_LEFTBRACKET
#define KEY_BACKSLASH	SDLK_BACKSLASH
#define KEY_RIGHTBRACKET	SDLK_RIGHTBRACKET
#define KEY_CARET	SDLK_CARET
#define KEY_UNDERSCORE	SDLK_UNDERSCORE
#define KEY_BACKQUOTE	SDLK_BACKQUOTE
#define KEY_AT	SDLK_AT
#define KEY_A	SDLK_a
#define KEY_B	SDLK_b
#define KEY_C	SDLK_c
#define KEY_D	SDLK_d
#define KEY_E	SDLK_e
#define KEY_F	SDLK_f
#define KEY_G	SDLK_g
#define KEY_H	SDLK_h
#define KEY_I	SDLK_i
#define KEY_J	SDLK_j
#define KEY_K	SDLK_k
#define KEY_L	SDLK_l
#define KEY_M	SDLK_m
#define KEY_N	SDLK_n
#define KEY_O	SDLK_o
#define KEY_P	SDLK_p
#define KEY_Q	SDLK_q
#define KEY_R	SDLK_r
#define KEY_S	SDLK_s
#define KEY_T	SDLK_t
#define KEY_U	SDLK_u
#define KEY_V	SDLK_v
#define KEY_W	SDLK_w
#define KEY_X	SDLK_x
#define KEY_Y	SDLK_y
#define KEY_Z	SDLK_z
#define KEY_DELETE	SDLK_DELETE
#define KEY_KP0	SDLK_KP0
#define KEY_KP1	SDLK_KP1
#define KEY_KP2	SDLK_KP2
#define KEY_KP3	SDLK_KP3
#define KEY_KP4	SDLK_KP4
#define KEY_KP5	SDLK_KP5
#define KEY_KP6	SDLK_KP6
#define KEY_KP7	SDLK_KP7
#define KEY_KP8	SDLK_KP8
#define KEY_KP9	SDLK_KP9
#define KEY_KP_PERIOD	SDLK_KP_PERIOD
#define KEY_KP_DIVIDE	SDLK_KP_DIVIDE
#define KEY_KP_MULTIPLY	SDLK_KP_MULTIPLY
#define KEY_KP_MINUS	SDLK_KP_MINUS
#define KEY_KP_PLUS	SDLK_KP_PLUS
#define KEY_KP_ENTER	SDLK_KP_ENTER
#define KEY_KP_EQUALS	SDLK_KP_EQUALS
#define KEY_F1	SDLK_F1
#define KEY_F2	SDLK_F2
#define KEY_F3	SDLK_F3
#define KEY_F4	SDLK_F4
#define KEY_F5	SDLK_F5
#define KEY_F6	SDLK_F6
#define KEY_F7	SDLK_F7
#define KEY_F8	SDLK_F8
#define KEY_F9	SDLK_F9
#define KEY_F10	SDLK_F10
#define KEY_F11	SDLK_F11
#define KEY_F12	SDLK_F12
#define KEY_F13	SDLK_F13
#define KEY_F14	SDLK_F14
#define KEY_F15	SDLK_F15
#define KEY_UP	SDLK_UP
#define KEY_DOWN	SDLK_DOWN
#define KEY_RIGHT	SDLK_RIGHT
#define KEY_LEFT	SDLK_LEFT
#define KEY_INSERT	SDLK_INSERT
#define KEY_HOME	SDLK_HOME
#define KEY_END	SDLK_END
#define KEY_PAGEUP	SDLK_PAGEUP
#define KEY_PAGEDOWN	SDLK_PAGEDOWN
#define KEY_NUMLOCK	SDLK_NUMLOCK
#define KEY_CAPSLOCK	SDLK_CAPSLOCK
#define KEY_SCROLLOCK	SDLK_SCROLLOCK
#define KEY_RSHIFT	SDLK_RSHIFT
#define KEY_LSHIFT	SDLK_LSHIFT
#define KEY_RCTRL	SDLK_RCTRL
#define KEY_LCTRL	SDLK_LCTRL
#define KEY_RALT	SDLK_RALT
#define KEY_LALT	SDLK_LALT
#define KEY_RMETA	SDLK_RMETA
#define KEY_LMETA	SDLK_LMETA
#define KEY_LSUPER	SDLK_LSUPER
#define KEY_RSUPER	SDLK_RSUPER
#define KEY_MODE	SDLK_MODE
#define KEY_COMPOSE	SDLK_COMPOSE
#define KEY_HELP	SDLK_HELP
#define KEY_PRINT	SDLK_PRINT
#define KEY_SYSREQ	SDLK_SYSREQ
#define KEY_BREAK	SDLK_BREAK
#define KEY_MENU	SDLK_MENU
#define KEY_POWER	SDLK_POWER
#define KEY_EURO	SDLK_EURO
/*#define KEY_UNDO	SDLK_UNDO*/
#define KEY_LAST	SDLK_LAST

/*
	O[oϐ
*/
EXTERN uint16 keyconv[KEY_LAST + 1]	/* L[ϊe[u */
#if defined(DEF_GLOBAL)
= {
	/* 0 */
	0,	/* KEY_NONE */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	
	/* 8 */
	GKEY_BACKSPACE,	/* KEY_BACKSPACE */
	GKEY_TAB,	/* KEY_TAB */
	0,
	0,
	GKEY_CLS,	/* KEY_CLEAR */
	GKEY_RETURN,	/* KEY_RETURN */
	0,
	0,

	/* 16 */
	0,
	0,
	0,
	GKEY_BREAK,	/* KEY_PAUSE */
	0,
	0,
	0,
	0,

	/* 24 */
	0,
	0,
	0,
	GKEY_OFF,	/* KEY_ESCAPE */
	0,
	0,
	0,
	0,

	/* 32 */
	GKEY_SPACE,	/* KEY_SPACE */
	0,	/* KEY_EXCLAIM */
	0,	/* KEY_QUOTEDBL */
	0,	/* KEY_HASH */
	0,	/* KEY_DOLLAR */
	0,
	0,	/* KEY_AMPERSAND */
	0,	/* KEY_QUOTE */

	/* 40 */
	GKEY_LKAKKO,	/* KEY_LEFTPAREN */
	GKEY_RKAKKO,	/* KEY_RIGHTPAREN */
	GKEY_ASTER,	/* KEY_ASTERISK */
	GKEY_PLUS,	/* KEY_PLUS */
	GKEY_COMMA,	/* KEY_COMMA */
	GKEY_MINUS,	/* KEY_MINUS */
	GKEY_PERIOD,	/* KEY_PERIOD */
	GKEY_SLASH,	/* KEY_SLASH */

	/* 48 */
	GKEY_0,	/* KEY_0 */
	GKEY_1,	/* KEY_1 */
	GKEY_2,	/* KEY_2 */
	GKEY_3,	/* KEY_3 */
	GKEY_4,	/* KEY_4 */
	GKEY_5,	/* KEY_5 */
	GKEY_6,	/* KEY_6 */
	GKEY_7,	/* KEY_7 */

	/* 56 */
	GKEY_8,	/* KEY_8 */
	GKEY_9,	/* KEY_9 */
	0,	/* KEY_COLON */
	GKEY_SEMICOLON,	/* KEY_SEMICOLON */
	0,	/* KEY_LESS */
	GKEY_EQUAL,	/* KEY_EQUALS */
	0,	/* KEY_GREATER */
	0,	/* KEY_QUESTION */

	/* 64 */
	0,	/* KEY_AT */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	
	/* 72 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,

	/* 80 */
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	
	/* 88 */
	0,
	0,
	0,
	GKEY_LKAKKO,	/* KEY_LEFTBRACKET */
	GKEY_SLASH,	/* KEY_BACKSLASH */
	GKEY_RKAKKO,	/* KEY_RIGHTBRACKET */
	0,	/* KEY_CARET */
	0,	/* KEY_UNDERSCORE */

	/* 96 */
	0,	/* KEY_BACKQUOTE */
	GKEY_A,	/* KEY_A */
	GKEY_B,	/* KEY_B */
	GKEY_C,	/* KEY_C */
	GKEY_D,	/* KEY_D */
	GKEY_E,	/* KEY_E */
	GKEY_F,	/* KEY_F */
	GKEY_G,	/* KEY_G */

	/* 104 */
	GKEY_H,	/* KEY_H */
	GKEY_I,	/* KEY_I */
	GKEY_J,	/* KEY_J */
	GKEY_K,	/* KEY_K */
	GKEY_L,	/* KEY_L */
	GKEY_M,	/* KEY_M */
	GKEY_N,	/* KEY_N */
	GKEY_O,	/* KEY_O */

	/* 112 */
	GKEY_P,	/* KEY_P */
	GKEY_Q,	/* KEY_Q */
	GKEY_R,	/* KEY_R */
	GKEY_S,	/* KEY_S */
	GKEY_T,	/* KEY_T */
	GKEY_U,	/* KEY_U */
	GKEY_V,	/* KEY_V */
	GKEY_W,	/* KEY_W */

	/* 120 */
	GKEY_X,	/* KEY_X */
	GKEY_Y,	/* KEY_Y */
	GKEY_Z,	/* KEY_Z */
	0,
	0,
	0,
	0,
	GKEY_BACKSPACE,	/* KEY_DELETE */

	/* 128 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 144 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 160 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 176 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 192 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 208 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 224 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 240 */
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,

	/* 256 */
	GKEY_0,	/* KEY_KP0 */
	GKEY_1,	/* KEY_KP1 */
	GKEY_2,	/* KEY_KP2 */
	GKEY_3,	/* KEY_KP3 */
	GKEY_4,	/* KEY_KP4 */
	GKEY_5,	/* KEY_KP5 */
	GKEY_6,	/* KEY_KP6 */
	GKEY_7,	/* KEY_KP7 */

	/* 264 */
	GKEY_8,	/* KEY_KP8 */
	GKEY_9,	/* KEY_KP9 */
	GKEY_PERIOD,	/* KEY_KP_PERIOD */
	GKEY_SLASH,	/* KEY_KP_DIVIDE */
	GKEY_ASTER,	/* KEY_KP_MULTIPLY */
	GKEY_MINUS,	/* KEY_KP_MINUS */
	GKEY_PLUS,	/* KEY_KP_PLUS */
	GKEY_RETURN,	/* KEY_KP_ENTER */

	/* 272 */
	GKEY_EQUAL,	/* KEY_KP_EQUAL */
	GKEY_UP,	/* KEY_UP */
	GKEY_DOWN,	/* KEY_DOWN */
	GKEY_RIGHT,	/* KEY_RIGHT */
	GKEY_LEFT,	/* KEY_LEFT */
	GKEY_INSERT,	/* KEY_INSERT */
	GKEY_CLS,	/* KEY_HOME */
	0,	/* KEY_END */
	
	/* 280 */
	0,	/* KEY_PAGEUP */
	0,	/* KEY_PAGEDOWN */
	0,	/* KEY_F1 */
	0,	/* KEY_F2 */
	0,	/* KEY_F3 */
	0,	/* KEY_F4 */
	0,	/* KEY_F5 */
	0,	/* KEY_F6 */

	/* 288 */
	0,	/* KEY_F7 */
	0,	/* KEY_F8 */
	0,	/* KEY_F9 */
	0,	/* KEY_F10 */
	0,	/* KEY_F11 */
	0,	/* KEY_F12 */
	0,	/* KEY_F13 */
	0,	/* KEY_F14 */
	
	/* 296 */
	0,	/* KEY_F15 */
	0,
	0,
	0,
	0,	/* KEY_NUMLOCK */
	0,	/* KEY_CAPSLOCK */
	0,	/* KEY_SCROLLLOCK */
	GKEY_SHIFT,	/* KEY_RSHIFT */

	/* 304 */
	GKEY_SHIFT,	/* KEY_LSHIFT */
	0,	/* KEY_RCTRL */
	0,	/* KEY_LCTRL */
	0,	/* KEY_RALT */
	0,	/* KEY_LALT */
	0,	/* KEY_RMETA */
	0,	/* KEY_LMETA */
	0,	/* KEY_LSUPER */
	
	/* 312 */
	0,	/* KEY_RSUPER */
	0,	/* KEY_MODE */
	0,	/* KEY_COMPOSE */
	GKEY_MENU,	/* KEY_HELP */
	0,	/* KEY_PRINT */
	0,	/* KEY_SYSREQ */
	GKEY_BREAK,	/* KEY_BREAK */
	GKEY_MENU,	/* KEY_MENU */

	/* 320 */
	GKEY_OFF,	/* KEY_POWER */
	0,	/* KEY_EURO */
	0	/* KEY_UNDO */
}
#endif
;

EXTERN uint16 keyconvShift[KEY_LAST + 1];
EXTERN uint16 keyconvCtrl[KEY_LAST + 1];

#endif

/*
	Copyright 2005 ~ 2008 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */
